/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <bin/proc.h>
#include <bin/types.h>
#include <page.h>
#include <kprintf.h>
#include <stddef.h>

int bin_proc_s_push(const void *const src, const size_t n, void *const user)
{
    struct bin_proc *const p = user;
    struct bin_stack *const s = &p->stack;
    const size_t max = 8192;

    if (n > max || s->sz > max - n)
    {
        kprintf("%s: stack overflow\n", p->path);
        return -1;
    }

    const int w = page_write(&s->page, s->sz, src, n);

    if (w < 0)
        return -1;
#if 0
    else if (!w)
        /* TODO: how to unlock? */
        return bin_proc_lock(p);
#endif

    s->sz += w;
    return w;
}
